
;;; Copyright (C) 2002 Thomas Mailund <thomas@mailund.dk>

;;; This file is not part of GNU Emacs, but it is distributed under the
;;; same conditions.

;;; ====================================================================

;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License as
;;; published by the Free Software Foundation; either version 2, or (at
;;; your option) any later version.

;;; This program is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
;;; General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this software; see the file COPYING. If not, write to the
;;; Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; ====================================================================

(provide 'dprog-constants)

(defconst dprog-mode-version "0.01" "Dprog mode version number")
(defun dprog-version nil
  "Displays dprog version."
  (interactive)
  (message (concat "Dprog-move version " dprog-mode-version)))

(defconst dprog-name-regex 
  "[a-zA-Z][a-zA-Z0-9_]*"
  "Regex matching dprog names.")

(defconst dprog-keywords-regex
  (eval-when-compile
    (regexp-opt '("globals" "parameters" "locals" "in" "end"
		  "val" "fun" "matrix"
		  "and" "or" "where" "when") 'words))
  "Regex matching dprog keywords.")


(defconst dprog-basic-types-regex
  (eval-when-compile
    (regexp-opt '("char" "int" "float" "true") ;well, 'true' isn't a type...
		'words))
  "Regex matching dprog basic types.")


(defconst dprog-open-block "{" "Regex matching dprog open blocks.")

(defconst dprog-close-block "}" "Regex matching dprog close blocks.")

(defconst dprog-block-kw-regex
  (eval-when-compile
    (regexp-opt '("globals" "parameters" "locals" "in" "end") 'words))
  "Regexp matching open/close blocks keywords.")
